image: node:14

.get_version: &get_version
  - 'export VERSION=$(cat package.json | grep version | head -1 | awk -F: ''{ print $2 }'' | sed ''s/[",]//g'' | tr -d ''[[:space:]]'')'

variables:
  PROJECT_SSH_URL: 'git@gitlab.com:tapioca-ufrn/multiprova/particularizacao.git'
  PROJECT_FOLDER: 'particularizacao'
  APP_NAME: 'particularizacao'

stages:
  - build-test
  - release
  - quality-analysis

build-test:
  stage: build-test
  before_script:
    - |
      {
        echo "repo_token: ${COVERALLS_REPO_TOKEN}"
      } | tee -a .coveralls.yml
  script:
    - npm ci
    - npm run lint
    - npm run build
    - npm run test-ci
  artifacts:
    name: '$CI_JOB_NAME-$CI_COMMIT_REF_SLUG'
    paths:
      - coverage/
      - lib/
    expire_in: 2 days

release:
  stage: release
  script:
    - npm ci --cache .npm --prefer-offline
    - npx semantic-release -b $CI_COMMIT_REF_NAME
  only:
    - master
  dependencies:
    - build-test

qa:
  image: emeraldsquad/sonar-scanner
  dependencies:
    - build-test
  stage: quality-analysis
  allow_failure: true
  script:
    - *get_version
    - sonar-scanner -Dsonar.projectKey=$CI_PROJECT_NAME -Dsonar.projectName=$CI_PROJECT_NAME -Dsonar.projectVersion=$VERSION -Dsonar.host.url=$SONAR_URL -Dsonar.login=$SONAR_TOKEN
